<?php

/*
Plugin Name: Horizontal carousel image slideshow
Plugin URI: http://www.gopiplus.com/work/2011/10/14/horizontal-carousel-image-slideshow-wordpress-plugin/
Description: Horizontal carousel image slideshow is a fabulous DHTML script for the showcasing of images on your site.
Author: Gopi.R
Version: 1.0
Author URI: http://www.gopiplus.com/work/2011/10/14/horizontal-carousel-image-slideshow-wordpress-plugin/
Donate link: http://www.gopiplus.com/work/2011/10/14/horizontal-carousel-image-slideshow-wordpress-plugin/
*/

// @copyright Copyright (C) 2010 - 2011 www.gopiplus.com, LLC
// @license   http://www.gnu.org/licenses/gpl-2.0.html GNU/GPLv2 only

global $wpdb, $wp_version;
define("wp_horizontalcarousel_table", $wpdb->prefix . "horizontalcarouse_plugin");

function ghcis_install() 
{
	global $wpdb;
	if($wpdb->get_var("show tables like '". wp_horizontalcarousel_table . "'") != wp_horizontalcarousel_table) 
	{
		$sSql = "CREATE TABLE IF NOT EXISTS `". wp_horizontalcarousel_table . "` (";
		$sSql = $sSql . "`ghcis_id` INT NOT NULL AUTO_INCREMENT ,";
		$sSql = $sSql . "`ghcis_path` TEXT CHARACTER SET utf8 COLLATE utf8_bin NOT NULL ,";
		$sSql = $sSql . "`ghcis_link` TEXT CHARACTER SET utf8 COLLATE utf8_bin NOT NULL ,";
		$sSql = $sSql . "`ghcis_target` VARCHAR( 50 ) NOT NULL ,";
		$sSql = $sSql . "`ghcis_title` VARCHAR( 500 ) NOT NULL ,";
		$sSql = $sSql . "`ghcis_order` INT NOT NULL ,";
		$sSql = $sSql . "`ghcis_status` VARCHAR( 10 ) NOT NULL ,";
		$sSql = $sSql . "`ghcis_type` VARCHAR( 100 ) NOT NULL ,";
		$sSql = $sSql . "`ghcis_extra1` VARCHAR( 100 ) NOT NULL ,";
		$sSql = $sSql . "`ghcis_extra2` VARCHAR( 100 ) NOT NULL ,";
		$sSql = $sSql . "`ghcis_date` datetime NOT NULL default '0000-00-00 00:00:00' ,";
		$sSql = $sSql . "PRIMARY KEY ( `ghcis_id` )";
		$sSql = $sSql . ")";
		$wpdb->query($sSql);
		
		$siteurl_link = get_option('siteurl') . "/";
		
		$IsSql = "INSERT INTO `". wp_horizontalcarousel_table . "` (`ghcis_path`, `ghcis_link`, `ghcis_target` , `ghcis_title` , `ghcis_order` , `ghcis_status` , `ghcis_type` , `ghcis_date`)"; 
		for($i=1; $i<=4; $i++)
		{
			$sSql = $IsSql . " VALUES ('$siteurl_link/wp-content/plugins/horizontal-carousel-image-slideshow/images/250x167_$i.jpg', '#', '_blank', 'Enter alt text here', '$i', 'YES', 'GROUP1', '0000-00-00 00:00:00');";
			$wpdb->query($sSql);
		}
	}
}

function ghcis_admin_options() 
{
	?>
<div class="wrap">
  <?php
  	global $wpdb;
    $title = __('Horizontal carousel image slideshow');
    $mainurl = get_option('siteurl')."/wp-admin/options-general.php?page=horizontal-carousel-image-slideshow/horizontal-carousel-image-slideshow.php";
    $DID=@$_GET["DID"];
    $AC=@$_GET["AC"];
    $submittext = "Insert Message";
	if($AC <> "DEL" and trim($_POST['ghcis_path']) <>"")
    {
			if($_POST['ghcis_id'] == "" )
			{
					$sql = "insert into ".wp_horizontalcarousel_table.""
					. " set `ghcis_path` = '" . mysql_real_escape_string(trim($_POST['ghcis_path']))
					. "', `ghcis_link` = '" . mysql_real_escape_string(trim($_POST['ghcis_link']))
					. "', `ghcis_title` = '" . mysql_real_escape_string(trim($_POST['ghcis_title']))
					. "', `ghcis_order` = '" . mysql_real_escape_string(trim($_POST['ghcis_order']))
					. "', `ghcis_type` = '" . mysql_real_escape_string(trim($_POST['ghcis_type']))
					. "'";	
			}
			else
			{
					$sql = "update ".wp_horizontalcarousel_table.""
					. " set `ghcis_path` = '" . mysql_real_escape_string(trim($_POST['ghcis_path']))
					. "', `ghcis_link` = '" . mysql_real_escape_string(trim($_POST['ghcis_link']))
					. "', `ghcis_title` = '" . mysql_real_escape_string(trim($_POST['ghcis_title']))
					. "', `ghcis_order` = '" . mysql_real_escape_string(trim($_POST['ghcis_order']))
					. "', `ghcis_type` = '" . mysql_real_escape_string(trim($_POST['ghcis_type']))
					. "' where `ghcis_id` = '" . $_POST['ghcis_id'] 
					. "'";	
			}
			$wpdb->get_results($sql);
    }
    
    if($AC=="DEL" && $DID > 0)
    {
        $wpdb->get_results("delete from ".wp_horizontalcarousel_table." where ghcis_id=".$DID);
    }
    
    if($DID<>"" and $AC <> "DEL")
    {
        $data = $wpdb->get_results("select * from ".wp_horizontalcarousel_table." where ghcis_id=$DID limit 1");
        if ( empty($data) ) 
        {
           echo "<div id='message' class='error'><p>No data available! use below form to create!</p></div>";
           return;
        }
        $data = $data[0];
        if ( !empty($data) ) $ghcis_id_x = htmlspecialchars(stripslashes($data->ghcis_id)); 
		if ( !empty($data) ) $ghcis_path_x = htmlspecialchars(stripslashes($data->ghcis_path)); 
        if ( !empty($data) ) $ghcis_link_x = htmlspecialchars(stripslashes($data->ghcis_link));
		if ( !empty($data) ) $ghcis_target_x = htmlspecialchars(stripslashes($data->ghcis_target));
        if ( !empty($data) ) $ghcis_title_x = htmlspecialchars(stripslashes($data->ghcis_title));
		if ( !empty($data) ) $ghcis_order_x = htmlspecialchars(stripslashes($data->ghcis_order));
		if ( !empty($data) ) $ghcis_status_x = htmlspecialchars(stripslashes($data->ghcis_status));
		if ( !empty($data) ) $ghcis_type_x = htmlspecialchars(stripslashes($data->ghcis_type));
        $submittext = "Update Message";
    }
    ?>
  <h2><?php echo wp_specialchars( $title ); ?></h2>
  <script language="JavaScript" src="<?php echo get_option('siteurl'); ?>/wp-content/plugins/horizontal-carousel-image-slideshow/setting.js"></script>
  <form name="ghcis_form" method="post" action="<?php echo $mainurl; ?>" onsubmit="return ghcis_submit()"  >
    <table width="100%">
      <tr>
        <td align="left" valign="middle">Enter Image URL:</td>
      </tr>
      <tr>
        <td align="left" valign="middle"><input name="ghcis_path" type="text" id="ghcis_path" value="<?php echo $ghcis_path_x; ?>" size="125" /></td>
      </tr>
      <tr>
        <td align="left" valign="middle">Enter Target Link:</td>
      </tr>
      <tr>
        <td align="left" valign="middle"><input name="ghcis_link" type="text" id="ghcis_link" value="<?php echo $ghcis_link_x; ?>" size="125" /></td>
      </tr>
      <tr>
        <td align="left" valign="middle">Enter Image Alt Text:</td>
      </tr>
      <tr>
        <td align="left" valign="middle"><input name="ghcis_title" type="text" id="ghcis_title" value="<?php echo $ghcis_title_x; ?>" size="125" /></td>
      </tr>
      <tr>
        <td align="left" valign="middle">Select Gallery Group:</td>
      </tr>
      <tr>
        <td align="left" valign="middle"><select name="ghcis_type" id="ghcis_type">
            <option value='GROUP1' <?php if($ghcis_type_x=='GROUP1') { echo 'selected' ; } ?>>Group1</option>
            <option value='GROUP2' <?php if($ghcis_type_x=='GROUP2') { echo 'selected' ; } ?>>Group2</option>
            <option value='GROUP3' <?php if($ghcis_type_x=='GROUP3') { echo 'selected' ; } ?>>Group3</option>
            <option value='GROUP4' <?php if($ghcis_type_x=='GROUP4') { echo 'selected' ; } ?>>Group4</option>
            <option value='GROUP5' <?php if($ghcis_type_x=='GROUP5') { echo 'selected' ; } ?>>Group5</option>
            <option value='GROUP6' <?php if($ghcis_type_x=='GROUP6') { echo 'selected' ; } ?>>Group6</option>
            <option value='GROUP7' <?php if($ghcis_type_x=='GROUP7') { echo 'selected' ; } ?>>Group7</option>
            <option value='GROUP8' <?php if($ghcis_type_x=='GROUP8') { echo 'selected' ; } ?>>Group8</option>
            <option value='GROUP9' <?php if($ghcis_type_x=='GROUP9') { echo 'selected' ; } ?>>Group9</option>
            <option value='GROUP0' <?php if($ghcis_type_x=='GROUP0') { echo 'selected' ; } ?>>Group0</option>
          </select>
          (This is to group the images) </td>
      </tr>
      <tr>
        <td align="left" valign="middle">Image Display Order:</td>
      </tr>
      <tr>
        <td width="78%" align="left" valign="middle"><input name="ghcis_order" type="text" id="ghcis_order" size="7" value="<?php echo $ghcis_order_x; ?>" maxlength="3" /></td>
      </tr>
      <tr>
        <td height="35" align="left" valign="bottom"><table width="100%">
            <tr>
              <td align="left"><input name="publish" lang="publish" class="button-primary" value="<?php echo $submittext?>" type="submit" />
                <input name="publish" lang="publish" class="button-primary" onclick="ghcis_redirect()" value="Cancel" type="button" /></td>
            </tr>
          </table></td>
      </tr>
      <input name="ghcis_id" id="ghcis_id" type="hidden" value="<?php echo $ghcis_id_x; ?>">
    </table>
  </form>
  <div class="tool-box">
    <?php
	$data = $wpdb->get_results("select * from ".wp_horizontalcarousel_table." order by ghcis_type,ghcis_order");
	if ( empty($data) ) 
	{ 
		echo "<div id='message' class='error'>No data available! use below form to create!</div>";
		return;
	}
	?>
    <form name="frm_ghcis_display" method="post">
      <table width="100%" class="widefat" id="straymanage">
        <thead>
          <tr>
            <th width="10%" align="left" scope="col">Group
              </td>
            <th width="66%" align="left" scope="col">Image URL
              </td>
            <th width="5%" align="left" scope="col">Order
              </td>
            <th width="8%" align="left" scope="col">Action
              </td>
          </tr>
        </thead>
        <?php 
        $i = 0;
        foreach ( $data as $data ) { 
        ?>
        <tbody>
          <tr class="<?php if ($i&1) { echo'alternate'; } else { echo ''; }?>">
            <td align="left" valign="middle"><?php echo(stripslashes($data->ghcis_type)); ?></td>
            <td align="left" valign="middle"><a target="_blank" href="<?php echo(stripslashes($data->ghcis_path)); ?>"><?php echo(stripslashes($data->ghcis_path)); ?></a></td>
            <td align="left" valign="middle"><?php echo(stripslashes($data->ghcis_order)); ?></td>
            <td align="left" valign="middle"><a href="options-general.php?page=horizontal-carousel-image-slideshow/horizontal-carousel-image-slideshow.php&DID=<?php echo($data->ghcis_id); ?>">Edit</a> &nbsp; <a onClick="javascript:ghcis_delete('<?php echo($data->ghcis_id); ?>')" href="javascript:void(0);">Delete</a></td>
          </tr>
        </tbody>
        <?php $i = $i+1; } ?>
      </table>
    </form>
  </div>
  Short code : [CAROUSELSHOW:GROUP=GROUP1:W=250:H=167:SPEED=2:DIRECTION=LR:SIDES=6] <br />
  
<h2>Plugin configuration</h2>
<ul>
    <li><a href="http://www.gopiplus.com/work/2011/10/14/horizontal-carousel-image-slideshow-wordpress-plugin/" target="_blank">Use the short code in the pages and posts.</a></li>
</ul>
<h2>Plugin help</h2>
<ul>
    <li>Plugin created by <a href="http://www.gopiplus.com/work/2011/10/14/horizontal-carousel-image-slideshow-wordpress-plugin/" target="_blank">www.gopiplus.com</a></li>
    <li><a href="http://www.gopiplus.com/work/2011/10/14/horizontal-carousel-image-slideshow-wordpress-plugin/" target="_blank">Click here for more help.</a></li>
    <li><a href="http://www.gopiplus.com/work/2011/10/14/horizontal-carousel-image-slideshow-wordpress-plugin/" target="_blank">Click here for live demo.</a></li>
</ul>

</div>
<?php
}

add_filter('the_content','ghcis_Show_Filter');

function ghcis_Show_Filter($content)
{
	return 	preg_replace_callback('/\[CAROUSELSHOW:(.*?)\]/sim','ghcis_Show_Filter_Callback',$content);
}

function ghcis_Show_Filter_Callback($matches) 
{
	global $wpdb;
	
	$scode = $matches[1];
	//[CAROUSELSHOW:GROUP=GROUP1:W=250:H=167:SPEED=2:DIRECTION=LR:SIDES=6]
	
	list($ghcis_type_main, $ghcis_width_main, $ghcis_height_main, $ghcis_speed_main, $ghcis_direction_main, $ghcis_sides_main) = split("[:.-]", $scode);

	list($ghcis_type_cap, $ghcis_type) = split('[=.-]', $ghcis_type_main);
	list($ghcis_width_cap, $ghcis_width) = split('[=.-]', $ghcis_width_main);
	list($ghcis_height_cap, $ghcis_height) = split('[=.-]', $ghcis_height_main);
	list($ghcis_speed_cap, $ghcis_speed) = split('[=.-]', $ghcis_speed_main);
	list($ghcis_direction_cap, $ghcis_direction) = split('[=.-]', $ghcis_direction_main);
	list($ghcis_sides_cap, $ghcis_sides) = split('[=.-]', $ghcis_sides_main);
	
	if(!is_numeric(@$ghcis_width)) { @$ghcis_width = 300 ;}
	if(!is_numeric(@$ghcis_height)) { @$ghcis_height = 250; }
	if(!is_numeric(@$ghcis_speed)) { @$ghcis_speed = 2; }
	if(!is_numeric(@$ghcis_sides)) { @$ghcis_sides = 4; }
	
	if($ghcis_direction == "LR")
	{
		@$direction = "true";
	}
	else
	{
		@$direction = "false";
	}
	
	@$divwidth = 300;
	@$divheight = $ghcis_height+2;
	if($ghcis_sides == 4)
	{
		$divwidth = (1.42*$ghcis_width)+3;
	}
	elseif($ghcis_sides == 6)
	{
		$divwidth = (2*$ghcis_width)+4;
	}
	elseif($ghcis_sides == 8)
	{
		$divwidth = (2.62*$ghcis_width)+5;
	}
	elseif($ghcis_sides == 12)
	{
		$divwidth = (3.87*$ghcis_width)+7;
	}
	else
	{
		$divwidth = 300;
	}
	
	$ghcis_random = "YES";
	
	$sSql = "select ghcis_path,ghcis_link,ghcis_target,ghcis_title from ".wp_horizontalcarousel_table." where 1=1";
	if($ghcis_type <> ""){ $sSql = $sSql . " and ghcis_type='".$ghcis_type."'"; }
	if($ghcis_random == "YES"){ $sSql = $sSql . " ORDER BY RAND()"; }else{ $sSql = $sSql . " ORDER BY ghcis_order"; }
	
	$data = $wpdb->get_results($sSql);
	
	$ghcis_count = 0;
	if ( ! empty($data) ) 
	{
		foreach ( $data as $data ) 
		{
			$ghcis_str =  '"' . $data->ghcis_path . '", "'. $data->ghcis_link .'",';
			$ghcis_returnstr = $ghcis_returnstr . $ghcis_str;
			$ghcis_count++;
		}
		$ghcis_returnstr = substr($ghcis_returnstr,0,(strlen($ghcis_returnstr)-1));
	}	
	else
	{
		$ghcis_returnstr = '"http://www.gopiplus.com/work/wp-content/uploads/pluginimages/250x167/250x167_4.jpg","http://www.codingforums.com"';
	}
	
	$siteurl_link = get_option('siteurl') . "/";
	
	$ghcis = $ghcis . '<script type="text/javascript">';
		$ghcis = $ghcis . 'var hcs_Image_Width='.$ghcis_width.'; ';
		$ghcis = $ghcis . 'var hcs_Image_Height='.$ghcis_height.'; ';
		$ghcis = $ghcis . 'var hcs_Border=true; ';
		$ghcis = $ghcis . 'var hcs_Border_Color="white"; ';
		$ghcis = $ghcis . 'var hcs_Speed='.$ghcis_speed.'; ';
		$ghcis = $ghcis . 'var hcs_Direction='.$direction.'; ';
		$ghcis = $ghcis . 'var hcs_NoOfSides='.$ghcis_sides.'; ';		
		$ghcis = $ghcis . 'hcs_Image_Sources=new Array('.$ghcis_returnstr.');';		
	$ghcis = $ghcis . '</script>';
	$ghcis = $ghcis . '<script type="text/javascript" src="'.$siteurl_link.'wp-content/plugins/horizontal-carousel-image-slideshow/horizontal-carousel-image-slideshow.js"></script>';
	$ghcis = $ghcis . '<div id="Carousel" style="position:relative">';
   		$ghcis = $ghcis . '<img src="'.$siteurl_link.'wp-content/plugins/horizontal-carousel-image-slideshow/placeholder.gif" width="'.$divwidth.'" height="'.$divheight.'">';
	$ghcis = $ghcis . '</div>';
	$ghcis = $ghcis . '<script type="text/javascript">';
	$ghcis = $ghcis . 'Carousel();';
	$ghcis = $ghcis . '</script>';

	
	return $ghcis;
}

function ghcis_add_to_menu() 
{
	add_options_page('Horizontal carousel image slideshow', 'Horizontal carousel image slideshow', 'manage_options', __FILE__, 'ghcis_admin_options' );
}

if (is_admin()) 
{
	add_action('admin_menu', 'ghcis_add_to_menu');
}

function ghcis_deactivation()
{
	
}

register_activation_hook(__FILE__, 'ghcis_install');
add_action('admin_menu', 'ghcis_add_to_menu');
register_deactivation_hook(__FILE__, 'ghcis_deactivation');
?>
